implementation module Control.Monad.Fix

import StdEnv
import Control.Applicative
import Control.Monad
import Data.Func
import Data.Functor

instance MonadFix ?
where
	mfix :: !(a -> ?a) -> ?a
	mfix f = let a = f (unJust a) in a
	where
		unJust (?Just x) = x
		unJust ?None  = abort "mfix Maybe: ?None"

instance MonadFix []
where
	mfix f = case fix (f o hd) of
		[]    -> []
		[x:_] -> [x : mfix (tl o f)]

