implementation module Data.Bifunctor

instance Bifunctor (,)
where
	bifmap f g t = let (a, b) = t in (f a, g b)

instance Bifunctor ((,,) x)
where
	bifmap f g t = let (x, a, b) = t in (x, f a, g b)

instance Bifunctor ((,,,) x y)
where
	bifmap f g t = let (x, y, a, b) = t in (x, y, f a, g b)

instance Bifunctor ((,,,,) x y z)
where
	bifmap f g t = let (x, y, z, a, b) = t in (x, y, z, f a, g b)

instance Bifunctor ((,,,,,) x y z a)
where
	bifmap f g t = let (x, y, z, a, b, c) = t in (x, y, z, a, f b, g c)
