implementation module Data.Functor

import StdEnv
import StdMaybe

instance Functor {}
where
	fmap :: (a -> b) !{a} -> {b}
	fmap f arr = {f a\\a<-:arr}

instance Functor {!}
where
	fmap :: (a -> b) !{!a} -> {!b}
	fmap f arr = {f a\\a<-:arr}

instance Functor []
where
	fmap :: (a -> b) ![a] -> [b]
	fmap f l = [f e \\ e <- l]

instance Functor [!] where
	fmap :: (a -> b) ![!a] -> [!b]
	fmap f l = [!f e \\ e <|- l]

instance Functor [ !] where
	fmap :: (a -> b) ![a!] -> [b!]
	fmap f l = [f e \\ e <|- l!]

instance Functor [!!] where
	fmap :: (a -> b) ![!a!] -> [!b!]
	fmap f l = [!f e \\ e <|- l!]

instance Functor ?
where
	fmap f m = mapMaybe f m

instance Functor ?^
where
	fmap f m = mapMaybe f m

instance Functor ((,) a)
where
	fmap f (x, y) = (x, f y)

instance Functor ((,,) a b)
where
	fmap f (x, y, z) = (x, y, f z)

instance Functor ((,,,) a b c)
where
	fmap f (x, y, z, a) = (x, y, z, f a)

instance Functor ((,,,,) a b c d)
where
	fmap f (x, y, z, a, b) = (x, y, z, a, f b)

instance Functor ((,,,,,) a b c d e)
where
	fmap f (x, y, z, a, b, c) = (x, y, z, a, b, f c)

instance Functor ((->) r)
where
	fmap f g = \x -> (f o g) x

